%define prerel 0
%define pre 0

%ifarch %{arm} aarch64 x86_64
%define build_docs 0
%else
%define build_docs 0
%endif

%define qtmajor 6
%define qtminor 4
%define qtsubminor 1

%define rel 1

%define major_private 1
%define qtversion %{qtmajor}.%{qtminor}.%{qtsubminor}

%define libqtwebsockets %mklibname qt6websockets %qtmajor
%define libqtwebsockets_d %mklibname qt6websockets -d

%if %prerel
%define qttarballdir qtwebsockets-everywhere-src-%{qtversion}-%pre
%else
%define qttarballdir qtwebsockets-everywhere-src-%{qtversion}
%endif

Name: qtwebsockets6
Version: %{qtversion}
Release: %mkrel %{rel}
Summary: Qt WebSockets component
Group: Development/KDE and Qt
License: LGPLv2 with exceptions or GPLv3 with exceptions and GFDL
URL:     https://www.qt.io/
Source0: https://download.qt.io/official_releases/qt/%{qtmajor}.%{qtminor}/%{version}/submodules/%{qttarballdir}.tar.xz
Patch0:  qtwebsockets-fix-requires.patch

BuildRequires: qtbase6-devel >= %{version}
BuildRequires: cmake(Qt6Qml) >= %{version}
BuildRequires: cmake(Qt6Quick) >= %{version}
BuildRequires: cmake(Qt6QuickTest) >= %{version}
BuildRequires: cmake(Qt6QmlIntegration) >= %{version}
BuildRequires: ninja
BuildRequires: qttools6


#Branch Patchs

#Trunk Patchs

#Patch from Mageia



%description
QtWebSockets is a pure Qt implementation of WebSockets - both client and
server.
It is implemented as a Qt add-on module, that can easily be embedded into
existing Qt projects. It has no other dependencies than Qt.

%files
%{_qt6_qmldir}/QtWebSockets/

#------------------------------------------------------------------------------

%if %{build_docs}
%package doc
Summary: QtWebSockets%{qtmajor} APIs and tools docs
Group:   Documentation
BuildArch: noarch
BuildRequires: qttools6
# This one is required to build QCH-format documentation
# for APIs and tools in this package set
BuildRequires: qttools6-assistant
Recommends: qttools6-assistant

%description doc
Documentation for APIs and tools in QtWebSockets6 package for use with
Qt Assistant.

%files doc
%{_qt6_docdir}/qtwebsockets.qch
%{_qt6_docdir}/qtwebsockets/
%endif

#------------------------------------------------------------------------------

%package -n %{libqtwebsockets}
Summary: Qt%{qtmajor} Component Library
Group: System/Libraries

%description -n %{libqtwebsockets}
Qt%{qtmajor} Component Library.

QtWebSockets is a pure Qt implementation of WebSockets - both client and
server.

%files -n %{libqtwebsockets}
%{_qt6_libdir}/libQt6WebSockets.so.%{qtmajor}*

#------------------------------------------------------------------------------

%package -n %{libqtwebsockets_d}
Summary: Devel files needed to build apps based on QtWebSockets
Group:    Development/KDE and Qt
Requires: %{name} = %{version}
Requires: %{libqtwebsockets} = %version
Requires: qtbase6-common-devel = %{version}
Provides: libqtwebsockets6-devel = %version
Provides: qtwebsockets6-devel = %version

Provides: libqtwebsockets6-private-devel = %version
Provides: libqt6websockets-private-devel = %version
Provides: qtwebsockets6-private-devel = %version
Provides: qt6websockets-private-devel = %version
Requires: qt6core-private-devel = %version

%description -n %{libqtwebsockets_d}
Devel files needed to build apps based on QtWebSockets.

%files -n %{libqtwebsockets_d}
%{_qt6_libdir}/cmake/Qt6Qml
%{_qt6_libdir}/cmake/Qt6WebSockets
%{_qt6_libdir}/cmake/Qt6BuildInternals
%{_qt6_libdir}/metatypes/qt6websockets_relwithdebinfo_metatypes.json
%{_qt6_libdir}/libQt6WebSockets.prl
%{_qt6_libdir}/libQt6WebSockets.so
%{_qt6_libdir}/pkgconfig/Qt6WebSockets.pc
%{_qt6_datadir}/modules/WebSockets.json
%{_qt6_includedir}/QtWebSockets
%{_qt6_archdatadir}/mkspecs/modules/*
%{_qt6_examplesdir}/*

#------------------------------------------------------------------------------

%prep
%setup -q -n qtwebsockets-everywhere-src-%{qtversion}
%autopatch -p1

%build
%cmake_qt6

%cmake_build

%if %{build_docs}
%__make docs
%endif

%install
%cmake_install

%if %{build_docs}
%make_install install_docs INSTALL_ROOT=%{buildroot}
%endif

install -d %{buildroot}%{_qt6_docdir}

# .la and .a files, die, die, die.
find %{buildroot} -name '*.la' -delete
find %{buildroot} -name '*.a' -delete


%changelog
* Thu Dec 15 2022 neoclust <neoclust> 6.4.1-1.mga9
+ Revision: 1923067
- New version 6.4.1
+ wally <wally>
- drop unneeded obsoletes

* Fri Sep 30 2022 neoclust <neoclust> 6.4.0-1.mga9
+ Revision: 1893456
- New version 6.4.0

* Tue Aug 30 2022 neoclust <neoclust> 6.3.1-1.mga9
+ Revision: 1882347
- New version 6.3.1

* Sat Jul 30 2022 wally <wally> 6.3.0-2.mga9
+ Revision: 1873222
- rebuild for core/release

* Thu Jun 02 2022 neoclust <neoclust> 6.3.0-1.mga9
+ Revision: 1861085
- New version 6.3.0

* Sun Apr 10 2022 tmb <tmb> 6.2.3-2.mga9
+ Revision: 1848548
- Mageia 9 Mass Rebuild

* Wed Mar 16 2022 neoclust <neoclust> 6.2.3-1.mga9
+ Revision: 1794417
- New version 6.2.3
+ papoteur <papoteur>
- imported package qtwebsockets6

